Loading...
Searching...
No Matches
pcl::GASDColorEstimation< PointInT, PointOutT > Class Template Reference
Module features

GASDColorEstimation estimates the Globally Aligned Spatial Distribution (GASD) descriptor for a given point cloud dataset given XYZ and RGB data. More...

`#include <pcl/features/gasd.h>`

Inheritance diagram for pcl::GASDColorEstimation< PointInT, PointOutT >:

## Public Types

using | Ptr = shared_ptr<GASDColorEstimation<PointInT, PointOutT> >
using | ConstPtr = shared_ptr<const GASDColorEstimation<PointInT, PointOutT> >
Public Types inherited from pcl::GASDEstimation< PointInT, GASDSignature984 >
using | Ptr
using | ConstPtr
Public Types inherited from pcl::Feature< PointInT, GASDSignature984 >
using | BaseClass
using | Ptr
using | ConstPtr
using | KdTree
using | KdTreePtr
using | PointCloudIn
using | PointCloudInPtr
using | PointCloudInConstPtr
using | PointCloudOut
using | SearchMethod
using | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| GASDColorEstimation (const Eigen::Vector3f &view_direction=Eigen::Vector3f(0.0f, 0.0f, 1.0f), const std::size_t shape_half_grid_size=3, const std::size_t shape_hists_size=1, const std::size_t color_half_grid_size=2, const std::size_t color_hists_size=12, const HistogramInterpolationMethod shape_interp=INTERP_NONE, const HistogramInterpolationMethod color_interp=INTERP_NONE)
| Constructor.
void | setColorHalfGridSize (const std::size_t chgs)
| Set the color half grid size.
void | setColorHistsSize (const std::size_t chs)
| Set the color histograms size (number of bins in the hue histogram for each cell of the 3D regular grid).
void | setColorHistsInterpMethod (const HistogramInterpolationMethod interp)
| Set the color histograms interpolation method.
Public Member Functions inherited from pcl::GASDEstimation< PointInT, GASDSignature984 >
| GASDEstimation (const Eigen::Vector3f &view_direction=Eigen::Vector3f(0.0f, 0.0f, 1.0f), const std::size_t shape_half_grid_size=4, const std::size_t shape_hists_size=1, const HistogramInterpolationMethod shape_interp=INTERP_TRILINEAR)
| Constructor.
void | setViewDirection (const Eigen::Vector3f &dir)
| Set the view direction.
void | setShapeHalfGridSize (const std::size_t shgs)
| Set the shape half grid size.
void | setShapeHistsSize (const std::size_t shs)
| Set the shape histograms size.
void | setShapeHistsInterpMethod (const HistogramInterpolationMethod interp)
| Set the shape histograms interpolation method.
const Eigen::Matrix4f & | getTransform () const
| Returns the transformation aligning the point cloud to the canonical coordinate system.
void | compute (PointCloudOut &output)
| Overloaded computed method from pcl::Feature.
Public Member Functions inherited from pcl::Feature< PointInT, GASDSignature984 >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Additional Inherited Members

Protected Member Functions inherited from pcl::GASDEstimation< PointInT, GASDSignature984 >
void | addSampleToHistograms (const Eigen::Vector4f &p, const float max_coord, const std::size_t half_grid_size, const HistogramInterpolationMethod interp, const float hbin, const float hist_incr, std::vector< Eigen::VectorXf > &hists)
| add a sample to its respective histogram, optionally performing interpolation.
void | computeFeature (PointCloudOut &output) override
| Estimate GASD descriptor.
Protected Member Functions inherited from pcl::Feature< PointInT, GASDSignature984 >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.
Protected Attributes inherited from pcl::GASDEstimation< PointInT, GASDSignature984 >
PointCloudIn | shape_samples_
| Point cloud aligned to the canonical coordinate system.
float | max_coord_
| Normalization factor with respect to axis-aligned bounding cube centered on the origin.
float | hist_incr_
| Normalized sample contribution with respect to the total number of points in the cloud.
std::size_t | pos_
| Current position of output descriptor point cloud.
Protected Attributes inherited from pcl::Feature< PointInT, GASDSignature984 >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointOutT = GASDSignature984>
class pcl::GASDColorEstimation< PointInT, PointOutT >

GASDColorEstimation estimates the Globally Aligned Spatial Distribution (GASD) descriptor for a given point cloud dataset given XYZ and RGB data.

The suggested PointOutT is pcl::GASDSignature984.

Note
  If you use this code in any academic work, please cite:

- J. Lima, V. Teichrieb. An Efficient Global Point Cloud Descriptor for Object Recognition and Pose Estimation. In Proceedings of the 29th SIBGRAPI - Conference on Graphics, Patterns and Images, Sao Jose dos Campos, Brazil, October 4-7 2016.

Author
  Joao Paulo Lima

Voxar Labs, Centro de Informatica, Universidade Federal de Pernambuco, Brazil

Departamento de Estatistica e Informatica, Universidade Federal Rural de Pernambuco, Brazil

Definition at line 256 of file gasd.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointOutT = GASDSignature984>

using pcl::GASDColorEstimation< PointInT, PointOutT >::ConstPtr = shared_ptr<const GASDColorEstimation<PointInT, PointOutT> >

Definition at line 261 of file gasd.h.

## Ptr

template<typename PointInT, typename PointOutT = GASDSignature984>

using pcl::GASDColorEstimation< PointInT, PointOutT >::Ptr = shared_ptr<GASDColorEstimation<PointInT, PointOutT> >

Definition at line 260 of file gasd.h.

## Constructor & Destructor Documentation

## GASDColorEstimation()

template<typename PointInT, typename PointOutT = GASDSignature984>

pcl::GASDColorEstimation< PointInT, PointOutT >::GASDColorEstimation | ( | const Eigen::Vector3f & | view_direction = Eigen::Vector3f (0.0f, 0.0f, 1.0f),
|  | const std::size_t | shape_half_grid_size = 3,
|  | const std::size_t | shape_hists_size = 1,
|  | const std::size_t | color_half_grid_size = 2,
|  | const std::size_t | color_hists_size = 12,
|  | const HistogramInterpolationMethod | shape_interp = INTERP_NONE,
|  | const HistogramInterpolationMethod | color_interp = INTERP_NONE )

inline

Constructor.

Parameters

  [in] | view_direction | view direction
  [in] | shape_half_grid_size | shape half grid size
  [in] | shape_hists_size | shape histograms size
  [in] | color_half_grid_size | color half grid size
  [in] | color_hists_size | color histograms size
  [in] | shape_interp | shape histograms interpolation method
  [in] | color_interp | color histograms interpolation method

Definition at line 272 of file gasd.h.

References pcl::Feature< PointInT, GASDSignature984 >::feature_name_, pcl::GASDEstimation< PointInT, GASDSignature984 >::GASDEstimation(), and pcl::INTERP_NONE.

## Member Function Documentation

## setColorHalfGridSize()

template<typename PointInT, typename PointOutT = GASDSignature984>

void pcl::GASDColorEstimation< PointInT, PointOutT >::setColorHalfGridSize | ( | const std::size_t | chgs | ) |

inline

Set the color half grid size.

Parameters

  [in] | chgs | color half grid size

Definition at line 291 of file gasd.h.

## setColorHistsInterpMethod()

template<typename PointInT, typename PointOutT = GASDSignature984>

void pcl::GASDColorEstimation< PointInT, PointOutT >::setColorHistsInterpMethod | ( | const HistogramInterpolationMethod | interp | ) |

inline

Set the color histograms interpolation method.

Parameters

  [in] | interp | color histograms interpolation method

Definition at line 309 of file gasd.h.

## setColorHistsSize()

template<typename PointInT, typename PointOutT = GASDSignature984>

void pcl::GASDColorEstimation< PointInT, PointOutT >::setColorHistsSize | ( | const std::size_t | chs | ) |

inline

Set the color histograms size (number of bins in the hue histogram for each cell of the 3D regular grid).

Parameters

  [in] | chs | color histograms size

Definition at line 300 of file gasd.h.

The documentation for this class was generated from the following files:

- pcl/features/gasd.h
- pcl/features/impl/gasd.hpp